=== test/CMakeLists.txt ===
add_subdirectory(src/dftbp)
add_subdirectory(app)
add_subdirectory(tools/dptools)
