=== app/misc/CMakeLists.txt ===
add_subdirectory(skderivs)
add_subdirectory(slakovalue)
add_subdirectory(units)
